<?php
  set_time_limit(0);  // no time limit to finish script!
  require_once('db_con.php');
  
// ************************************************************************** 

 $internal_path = "E:/c64/";

// ************************************************************************** 
 
  function searchdisk($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;
    $filename = $internal_path.$dir.$dir_entry;
    $fp = fopen($filename,'r');
    fseek($fp,91521);    // = 256*21*17 + 1 = 91393 + header info! 91649
    $d64disklabel = fread($fp,32);
    $d64disklabel = substr($d64disklabel,15,16);
    $d64disklabel = str_replace('"',' ',$d64disklabel);
    $d64disklabel = str_replace('\\',' ',$d64disklabel);
    $d64diskid = fread($fp,32); 
    $d64diskid = substr($d64diskid,1,5);
    $d64diskid = str_replace('"',' ',$d64diskid);
    $d64diskid = str_replace('\\',' ',$d64diskid);
    $disk_id = $DB->add_disk($dir_entry, $d64disklabel.$d64diskid, $pack_name.$dir, $pack_id);
    fseek($fp,64,SEEK_CUR); 
    for($i=0;$i<144;$i++)
    {
      $entry = fread($fp,32);
      $track = ord(substr($entry,2,1));
      $sector = ord(substr($entry,3,1));
      //illegal track begins..  else 0/0 is default end of DIR
      if ( ($track>41)) {fclose($fp);return;}
           
      $c64_filetype = ord(substr($entry,1,1));
      switch ($c64_filetype) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }
      if ($c64_filetype<>'UNK')
      {   
        $c64_filename = trim(substr($entry,4,16));
        $c64_filename = str_replace('"',' ',$c64_filename);
        $c64_filename = str_replace('\\',' ',$c64_filename);
        $c64_filename = str_replace(chr(20),' ',$c64_filename); // remove $00 chars
        if ($c64_filename<>'')
        {
            $file_size = ord(substr($entry,29,1));
            $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id);
        } 
      }
    }
    fclose($fp);
  }


  // convert low, hi byte to hex        
  function lowhi2hex($low,$hi){
        if (strlen($low)==1) {$low = '0'.$low;}
        return hexdec($hi.$low);
        }

  function t64_filetype($value){
        switch ($value)
          {
            case "2"   : $t64type='*prg' ; break;               
            case "129" : $t64type='seq' ; break;               
            case "130" : $t64type='prg' ; break;               
            case "194" : $t64type='prg<' ; break;               
            default    : $t64type='unk'; 
          }
        return $t64type;
  }
  
  
  function searchtape($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;   
    $filename = $internal_path.$dir.$dir_entry;
    $file_size = filesize($filename);
    $fp = fopen($filename,'r');
    $c64_image = fread($fp,$file_size);

    // verify that is a C64S or C64 file
    if (substr($c64_image,0,3)<>'C64') return false;  

    $header = substr($c64_image,34,4);
    $s_hi = dechex(ord(substr($header,1,1)));
    $s_low  = dechex(ord(substr($header,2,1)));          
    $num_entries = hexdec(lowhi2hex($s_low,$s_hi));
    $c64_label = substr($c64_image,40,24);

    $disk_id = $DB->add_disk($dir_entry, $c64_label, $pack_name.$dir, $pack_id);
    for($i=0;$i<$num_entries;$i++)
            {
              $offset = (32*$i)+64;
              $entry = substr($c64_image,$offset,32);
              $c64_filetype = t64_filetype((ord(substr($entry,1,1))));
              
              $s_low = dechex(ord(substr($entry,2,1)));
              $s_hi  = dechex(ord(substr($entry,3,1)));
              $start = lowhi2hex($s_low,$s_hi);

              $e_low = dechex(ord(substr($entry,4,1)));
              $e_hi  = dechex(ord(substr($entry,5,1)));
              $end = lowhi2hex($e_low,$e_hi);

              $offset_low = dechex(ord(substr($entry,8,1)));
              $offset_hi  = dechex(ord(substr($entry,9,1)));
              $file_offset = lowhi2hex($offset_low,$offset_hi);

              $c64_filename = substr($entry,16,32);
              $file_size = ceil(($end-$start)/254);

              $c64_filename = str_replace('"',' ',$c64_filename);
              $c64_filename = str_replace('\\',' ',$c64_filename);
              $DB->add_release($c64_filename, $c64_filetype, ceil(($end-$start)/256), $disk_id);
            }
    fclose($fp);
  }  
  
  
  function searchPC64($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;
    $filename = $internal_path.$dir.$dir_entry;
    
    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id);
    $filesize = ceil((filesize($filename)-26)/254);
    $c64_filename = file_get_contents($filename,false,NULL,8,16);

    $c64_filename = str_replace('"',' ',$c64_filename);
    $c64_filename = str_replace('\\',' ',$c64_filename);

    $c64_filename = str_replace(chr(0),' ',$c64_filename); // remove $00 chars
    $c64_filetype = 'PRG(p00)';
    $DB->add_release($c64_filename, $c64_filetype, '0', $disk_id);
  }  


  function searchPRG($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;  
    $filename = $internal_path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id);
    $filesize = ceil((filesize($filename))/254);
    $c64_filename = basename(str_replace('.prg','',$filename)); // remove .PRG extension
    $c64_filetype = 'PRG(prg)';
    $c64_filename = str_replace('"',' ',$c64_filename);
    $c64_filename = str_replace('\\',' ',$c64_filename);
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id);
  }


  function searchUNK($dir, $dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;  
    $filename = $internal_path.$dir.$dir_entry;

    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id);
    $filesize = ceil((filesize($filename)-26)/256);
    $c64_filename = $dir_entry; 
    $c64_filetype = 'UNK(prg)';

    $c64_filename = str_replace('"',' ',$c64_filename);
    $c64_filename = str_replace('\\',' ',$c64_filename);  
    $DB->add_release($c64_filename, $c64_filetype, $filesize, $disk_id);
  }  
  
  
  function zplit($str,$chr_val)
  {
   // takes a given string $str, and a char_value (0-255)
   // returns the (sub)string until first ord($str[$i])==$chr_val 
   $stop = false;$i= 0;$res = "";          
   while (!$stop)
   {
    $p = substr($str,$i,1);
    if (strcmp(ord($p),$chr_val)<>0) $res .= $p;
    else $stop = true;
    $i++;
    if ($i>strlen($str)) break;            
   }
   return $res;       
  }
  
  function searchLNX($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;  
    $filename = $internal_path.$dir.$dir_entry;

    $fp = fopen($filename,'r');
    $dirSize = zplit(substr($fp,96,4), '20');
    $label = zplit(substr($fp,100,40), 13);
    $num_entries = trim(zplit(substr($fp,100+strlen($label)+2,4), '13'));
    $data_offset = $dir_size * 254; // binary data begins here

    $disk_id = $DB->add_disk($dir_entry, $label, $pack_name.$dir, $pack_id);    

    // Get dir elements          
    $dir_start = 100 + strlen($label) + strlen($num_entries) + 4;
    $offset = $dir_start;

    for($i=0;$i<$num_entries;$i++)
    {
       $c64_filename = zplit(substr($fp,$offset,16),13);    
       $offset = $offset + 16 + 1;
       $file_size_B = zplit(substr($fp,$offset,5),13);
       $offset = $offset + 1 + strlen($file_size_B);
       $lnx_type = zplit(substr($$fp,$offset,6),13);
       if ($lnx_type=='P') {$c64_filetype = 'prg';}
       else if ($lnx_type=='S') {$c64_filetype = 'seq';}
       else if  ($lnx_type=='R') {$c64_filetype = 'rel';}
       else {$c64_filetype = 'unk';}

       $offset = $offset + 2;
       $LSU_byte = zplit(substr($fp,$offset,6),13); // last sector useage                

       $offset = $offset + 1 + strlen($LSU_byte);
       $data_offset = $data_offset + $file_size_B*254;
 
       $c64_filename = str_replace('"',' ',$c64_filename);
       $c64_filename = str_replace('\\',' ',$c64_filename);
       $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id);
    }
    fclose($fp);
  }  
  
  
  function searchLNX_old($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;  
    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id);
    $filename = $internal_path.$dir.$dir_entry;

    $fp = fopen($filename,'r');
    fseek($fp,125);    //
    $NumDirEntries = fread($fp,1);
    fseek($fp,2,SEEK_CUR);
    for($i=0;$i<$NumDirEntries;$i++)
    {
      $entry = fread($fp,30);
      $c64_filename = substr($entry,0,16);
      $file_size = substr($entry,17,5);    

      if (stripos(substr($entry,18,14),'p')) {$c64_filetype = 'PRG(lnx)';}
      else if (stripos(substr($entry,18,14),'s')) {$c64_filetype = 'SEQ(lnx)';}
      else if (stripos(substr($entry,18,14),'r')) {$c64_filetype = 'REL(lnx)';}
      else {$c64_filetype = 'UNK(lnx)';}
      
      $c64_filename = str_replace('"',' ',$c64_filename);
      $c64_filename = str_replace('\\',' ',$c64_filename);

      $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id);
    }
    fclose($fp);
  }  
  

  function searchdisk81($dir,$dir_entry)
  {
    global $DB;
    global $internal_path;
    global $pack_id;
    global $pack_name;
    $disk_id = $DB->add_disk($dir_entry, ' unknown ', $pack_name.$dir, $pack_id);
    $filename = $internal_path.$dir.$dir_entry;

    $fp = fopen($filename,'r');
    fseek($fp,400129); // (256*39*40)+(256*3)+1
    for($i=0;$i<296;$i++) //296
    {
      $track = ord(substr($entry,2,1));
      $sector = ord(substr($entry,3,1));
      if ( ($track>81)) {fclose($fp);return;}
      $entry = fread($fp,32);
           
      $c64_filetype = ord(substr($entry,1,1));
      switch ($c64_filetype) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }

      if ($c64_filetype<>'UNK')
      {
        $c64_filename = substr($entry,4,16);
        $file_size = ord(substr($entry,29,1));

        $c64_filename = str_replace('"',' ',$c64_filename);
        $c64_filename = str_replace('\\',' ',$c64_filename);
        $DB->add_release($c64_filename, $c64_filetype, $file_size, $disk_id);
      }
    }
    fclose($fp);
  }
  
function traversedir($path,$dir) 
  {
    $dir_list = scandir($path.$dir);     
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($path.$dir.$dir_entry)) 
        {
          traversedir($path, $dir.$dir_entry.'/');
        }
        else if (is_file($path.$dir.$dir_entry)) 
        {
          $file_extension = strtolower(substr(strrchr($dir_entry,"."),1));
          switch($file_extension) 
          {
            case "d64": searchdisk($dir, $dir_entry); break;
            case "t64": searchtape($dir, $dir_entry); break;
            case "lnx": searchlnx($dir, $dir_entry);  break;
            case "p00": searchPC64($dir, $dir_entry); break;
            case "prg": searchPRG($dir, $dir_entry);  break;
            case "d81": searchdisk81($dir, $dir_entry); break;
            // case "" :   searchUNK($dir, $dir_entry);  break;
            default: ; // do nothing!
          }                 
        }
        else
        {
          echo "Unknown!!!!!!! ".$dir.$dir_list[$i]."<br>";
        }
      }  
    } 
  }
  
  
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title>Import by MdZ</title>
  </head>
  <body>
<h2 style="display:inline;">Import by MdZ, version 0.006 </h2>
<BR>
<?

$pack_name = (!empty($_REQUEST['sel_pack'])) ? $_REQUEST['sel_pack'] : null;
$import_btn = (!empty($_REQUEST['import_btn'])) ? $_REQUEST['import_btn'] : null;

if (($import_btn)  AND ($pack_name))
{ 
    Echo "Importing ".$pack_name." ...";  

    $pack_name .= "/";  
    $internal_path .= $pack_name;   
    if (is_dir($internal_path))
    {
      echo "create pack...$pack_name<br>";
      if ( ($DB->pack_name_exists($pack_name)<>0) AND ($pack_name<>'') )
      { 
        echo "<br><b>Pack $pack_name is already in Spunk... nothing was done!</b>";
      }
      else
      {    
        $pack_id = $DB->add_pack($pack_name);
        traversedir($internal_path,'');
        echo "<h3>$pack_name was succesfully imported!</h3>";
      }
    }
    else
    {
      echo "<h3>not a valid dir $pack_name</h3>";  
    }
 }   


    $dir_list = scandir($internal_path);     
    echo "<form name='form_add_pack' action='$PHP_SELF' method='post'>";
    echo "<select name='sel_pack'>";
    echo "<option disabled value=''>Chose pack to import</option>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($internal_path.$dir_entry)) 
        {
          // echo $dir_entry.'<br>';
          if ($DB->pack_name_exists($dir_entry."/")==0)
          { 
            echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
          }
        }
      }  
     }
    echo "</select>";
    echo "<input type='submit' name='import_btn' value='Import'>";
    echo "<br><br></form>";
?>

</body>
</html>

